/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package compilador_oraciones;

import java.io.IOException;
import java.util.ArrayList;

/**
 *
 * @author kelly
 */
public class Compilador_Oraciones {

    AnalizadorLexico objAnalizadorLexico = new AnalizadorLexico();
    private Token token;
    private boolean finalizado_con_errores = false;
    private int numero_errores;
    public ArrayList<Token> TokenPalabras = new ArrayList();

    public ArrayList<Token> getPalabras() {
        return TokenPalabras;
    }

    public int compilar(String fuente) throws IOException {
        objAnalizadorLexico.setInformacion(fuente);
        numero_errores = 0;
        this.finalizado_con_errores = false;
        this.objAnalizadorLexico.tratVistazo = true;
        gramatica();
        resumen();
        return numero_errores;
    }

    void gramatica() throws IOException {
        token = getSiguienteToken();
        sintagmaNominal();
        while (objAnalizadorLexico.tratVistazo) {
            token = getSiguienteToken();
            if (token.getEtiqueta() != Etiqueta.Delimitador) {
                token.setError("Esta posición se ve afectada por la anterior");
                TokenPalabras.add(token);
            }
        }
    }

    private void sintagmaNominal() throws IOException {
        if (token.getEtiqueta() == Etiqueta.Determinante) {
            token.setError("Correcto :)");
            TokenPalabras.add(token);
            token = getSiguienteToken();
            if (token.getEtiqueta() == Etiqueta.Nucleo) {
                token.setError("Correcto :)");
                TokenPalabras.add(token);
                token = getSiguienteToken();
                if (token.getEtiqueta() == Etiqueta.Delimitador) {
                    if (objAnalizadorLexico.tratVistazo) {
                        token = getSiguienteToken();
                    }

                } else {
                    adyacente();
                }
            } else {
                token.setError("En esta posición va el Núcleo: Sustantivo");
                TokenPalabras.add(token);
                errorSintactico();
            }
        } else {
            token.setError("En esta posición va un Artículo o Posesivo o Demostrativo");
            TokenPalabras.add(token);
            errorSintactico();
        }
    }

    private void adyacente() throws IOException {
        if (token.getEtiqueta() == Etiqueta.advCantidad || token.getEtiqueta() == Etiqueta.adjCalificativo) {
            sintagmaAdjetival();
        } else if (token.getEtiqueta() == Etiqueta.verbCopulativo || token.getEtiqueta() == Etiqueta.verbPresente) {
            sintagmaVerbal();
        } else if (token.getEtiqueta() == Etiqueta.preposicion) {
            sintagmaPreposicional();
        } else {
            token.setError("En esta posición va un Adverbio o Adjetivo o Verbo Copulativo o Verbo Presente o Preposicion");
            TokenPalabras.add(token);
            errorSintactico();
        }
    }

    private void sintagmaAdjetival() throws IOException {
        if (token.getEtiqueta() == Etiqueta.advCantidad) {
            token.setError("Correcto :)");
            TokenPalabras.add(token);
            token = getSiguienteToken();
            if (token.getEtiqueta() == Etiqueta.adjCalificativo) {
                token.setError("Correcto :)");
                TokenPalabras.add(token);
                token = getSiguienteToken();
            } else {
                token.setError("En esta posición va un Adjetivo Calificativo");
                TokenPalabras.add(token);
                errorSintactico();
            }
        } else if (token.getEtiqueta() == Etiqueta.adjCalificativo) {
            token.setError("Correcto :)");
            TokenPalabras.add(token);
            token = getSiguienteToken();
        } else {
            token.setError("En esta posición va un Adverbio o Adjetivo Calificativo");
            TokenPalabras.add(token);
            errorSintactico();
        }
    }

    private void sintagmaVerbal() throws IOException {
        if (token.getEtiqueta() == Etiqueta.verbCopulativo) {
            predicadoNominal();
        } else if (token.getEtiqueta() == Etiqueta.verbPresente) {
            predicadoVerbal();
        } else {
            token.setError("En esta posición va un Verbo Copulativo o Verbo Presente");
            TokenPalabras.add(token);
            errorSintactico();
        }
    }

    private void sintagmaPreposicional() throws IOException {
        if (token.getEtiqueta() == Etiqueta.preposicion) {
            token.setError("Correcto :)");
            TokenPalabras.add(token);
            token = getSiguienteToken();
            if (token.getEtiqueta() == Etiqueta.Determinante) {
                sintagmaNominal();
            } else if (token.getEtiqueta() == Etiqueta.advCantidad || token.getEtiqueta() == Etiqueta.adjCalificativo) {
                sintagmaAdjetival();
            } else if (token.getEtiqueta() == Etiqueta.preposicion) {
                sintagmaPreposicional();
            } else {
                token.setError("En esta posición va un Articulo o Demostrativo o Posesivo o Adverbio o Adjetivo o Preposicion");
                TokenPalabras.add(token);
                errorSintactico();
            }
        } else {
            token.setError("En esta posición va una Preposición");
            TokenPalabras.add(token);
            errorSintactico();
        }
    }

    private void predicadoNominal() throws IOException {
        if (token.getEtiqueta() == Etiqueta.verbCopulativo) {
            token.setError("Correcto :)");
            TokenPalabras.add(token);
            token = getSiguienteToken();
            atributo();
        } else {
            token.setError("En esta posición va un Verbo Copulativo");
            TokenPalabras.add(token);
            errorSintactico();
        }
    }

    private void predicadoVerbal() throws IOException {
        if (token.getEtiqueta() == Etiqueta.verbPresente) {
            token.setError("Correcto :)");
            TokenPalabras.add(token);
            token = getSiguienteToken();
            if (token.getEtiqueta() == Etiqueta.Determinante) {
                sintagmaNominal();
            } else if (token.getEtiqueta() == Etiqueta.preposicion) {
                sintagmaPreposicional();
            } else if (token.getEtiqueta() == Etiqueta.Delimitador) {
                if (objAnalizadorLexico.tratVistazo) {
                    token = getSiguienteToken();
                }

            } else {
                token.setError("En esta posición va un Artículo o Demostrativo o Posesivo o Preposicion");
                TokenPalabras.add(token);
                errorSintactico();
            }
        } else {
            token.setError("En esta posición va un Verbo Presente");
            TokenPalabras.add(token);
            errorSintactico();
        }
    }

    private void atributo() throws IOException {
        if (token.getEtiqueta() == Etiqueta.advCantidad || token.getEtiqueta() == Etiqueta.adjCalificativo) {
            sintagmaAdjetival();
        } else if (token.getEtiqueta() == Etiqueta.preposicion) {
            sintagmaPreposicional();
        } else if (token.getEtiqueta() == Etiqueta.verbGerundio) {
            token.setError("Correcto :)");
            TokenPalabras.add(token);
            token = getSiguienteToken();
        } else {
            token.setError("En esta posición va un Adverbio o Adjetivo o Preposicion o Verbo Gerundio");
            TokenPalabras.add(token);
            errorSintactico();
        }
    }

    private void errorSintactico() throws IOException {
        finalizado_con_errores = true;
    }

    private void resumen() {
        if (!finalizado_con_errores) {
            numero_errores = 0;
        } else {
            numero_errores = 1;
        }
    }

    public Token getSiguienteToken() throws IOException {
        Token retorno = this.objAnalizadorLexico.explorar();
        return retorno;
    }
}
