/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package compilador_oraciones;

import java.util.ArrayList;

/**
 *
 * @author kelly
 */
public class Diccionario {    
    ArrayList articulo = new ArrayList();
    ArrayList demostrativo = new ArrayList();
    ArrayList posesivo = new ArrayList();
    ArrayList sustantivoComun = new ArrayList();
    ArrayList sustantivoDerivado = new ArrayList();
    ArrayList sustantivoDiminutivo = new ArrayList();
    ArrayList advCantidad = new ArrayList();
    ArrayList adjCalificativo = new ArrayList();
    ArrayList verbCopulativo = new ArrayList();
    ArrayList verbGerundio = new ArrayList();
    ArrayList verbPresente = new ArrayList();
    ArrayList palabraSimple = new ArrayList();
    ArrayList preposicion = new ArrayList();
    
    public Diccionario() {
        cargarDiccionarioDeterminante();     
        cargarDiccionarioNucleo();
        cargarDiccionarioAdvCantidad();
        cargarDiccionarioAdjCalificativo();
        cargarDiccionarioVerbCopulativo();
        cargarDiccionarioVerbGerundio();
        cargarDiccionarioVerbPresente();
        cargarDiccionarioPalabraSimple();
        cargarDiccionarioPreposicion();
    }
    
    public boolean validarDeterminante(String lexema){
        if (articulo.contains(lexema)||demostrativo.contains(lexema)||posesivo.contains(lexema))
            return true;
        else
            return false;        
    }
    public boolean varlidarNucleo(String lexema){
        if (sustantivoComun.contains(lexema)||sustantivoDerivado.contains(lexema)||sustantivoDiminutivo.contains(lexema))
            return true;
        else
            return false;        
    }
    public boolean validarAdvCantidad(String lexema){
        if (advCantidad.contains(lexema))
            return true;
        else
            return false;        
    }
    public boolean validarAdjCalificativo(String lexema){
        if (adjCalificativo.contains(lexema))
            return true;
        else
            return false;        
    }
    public boolean validarVerbCopulativo(String lexema){
        if (verbCopulativo.contains(lexema))
            return true;
        else
            return false;        
    }
    public boolean validarVerbGerundio(String lexema){
        if (verbGerundio.contains(lexema))
            return true;
        else
            return false;        
    }
    public boolean validarVerbPresente(String lexema){
        if (verbPresente.contains(lexema))
            return true;
        else
            return false;        
    }
    public boolean validarPalabraSimple(String lexema){
        if (palabraSimple.contains(lexema))
            return true;
        else
            return false;        
    }
    public boolean validarPreposicion(String lexema){
        if (preposicion.contains(lexema))
            return true;
        else
            return false;        
    }
    
    
    private void cargarDiccionarioDeterminante(){
        //Determinante: Artículo
        articulo.add("la");
        articulo.add("una");
        articulo.add("las");
        articulo.add("unas");
        articulo.add("el");
        articulo.add("un");
        articulo.add("los");
        articulo.add("unos");

        //Determinante: Demostrativo
        demostrativo.add("esta");
        demostrativo.add("esa");
        demostrativo.add("aquella");
        demostrativo.add("estas");
        demostrativo.add("esas");
        demostrativo.add("aquellas");
        demostrativo.add("este");
        demostrativo.add("ese");
        demostrativo.add("aquel");
        demostrativo.add("estos");
        demostrativo.add("esos");
        demostrativo.add("aquelllos");

        //Determinante: Posesivo
        posesivo.add("mi");
        posesivo.add("tu");
        posesivo.add("su");
        posesivo.add("nuestra");
        posesivo.add("vuestra");
        posesivo.add("mis");
        posesivo.add("tus");
        posesivo.add("sus");
        posesivo.add("nuestras");
        posesivo.add("vuestras");
        posesivo.add("nuestro");
        posesivo.add("vuestro");
        posesivo.add("nuestros");
        posesivo.add("vuestros");
    }
    
    private void cargarDiccionarioNucleo(){
        //Núcleo: Sustantivo Común
        sustantivoComun.add("gata");
        sustantivoComun.add("gatas");
        sustantivoComun.add("gato");
        sustantivoComun.add("gatos");
        
        sustantivoComun.add("dinosaurio");
        sustantivoComun.add("dinosaurios");
        
        sustantivoComun.add("guitarra");
        sustantivoComun.add("guitarras");
        sustantivoComun.add("pelota");
        sustantivoComun.add("pelotas");
                
                
        //Núcleo: Sustantivo Diminutivo
        sustantivoDiminutivo.add("gatita");
        sustantivoDiminutivo.add("gatitas");
        sustantivoDiminutivo.add("gatito");
        sustantivoDiminutivo.add("gatitos");
        sustantivoDiminutivo.add("ballenita");
    }
    
    private void cargarDiccionarioAdvCantidad(){
        //Lista de adverbios de cantidad
        advCantidad.add("muy");
        advCantidad.add("bastante");
        advCantidad.add("demasiado");
        advCantidad.add("más");
        advCantidad.add("algo");
        advCantidad.add("extremandamente");
        advCantidad.add("infinitamente");        
        advCantidad.add("tanto");        
    }
    
    private void cargarDiccionarioAdjCalificativo(){
        //Lista de adjetivos Calificativos
        adjCalificativo.add("celeste");
        adjCalificativo.add("rosado");
        adjCalificativo.add("naranja");
        adjCalificativo.add("verde"); 
        adjCalificativo.add("feliz");
    }
    private void cargarDiccionarioVerbCopulativo(){
        //Lista de verbosCopulativos
        verbCopulativo.add("es");
        verbCopulativo.add("fue");
        verbCopulativo.add("parece");
        verbCopulativo.add("está");
        verbCopulativo.add("son");
        verbCopulativo.add("fueron");
        verbCopulativo.add("parecen");
        verbCopulativo.add("estan");
    }
    private void cargarDiccionarioVerbGerundio(){
        //Lista de verbos Gerundios
        verbGerundio.add("pintando");
        verbGerundio.add("tocando");
        verbGerundio.add("pensando");
        verbGerundio.add("corriendo");
        verbGerundio.add("jugando");
        verbGerundio.add("leyendo");
        verbGerundio.add("estudiando");
        verbGerundio.add("caminando");
        verbGerundio.add("cantando");
        verbGerundio.add("cocinando");
        verbGerundio.add("escuchando");
        verbGerundio.add("limpiando");
    }
    private void cargarDiccionarioVerbPresente(){
        //Lista de verbos Presentes
        verbPresente.add("pinta");
        verbPresente.add("toca");
        verbPresente.add("piensa");
        verbPresente.add("corre");
        verbPresente.add("juega");
        verbPresente.add("estudia");
        verbPresente.add("camina");
        verbPresente.add("canta");
        verbPresente.add("cocina");
        verbPresente.add("esucha");
        verbPresente.add("limpia");        
        verbPresente.add("pintan");
        verbPresente.add("tocan");
        verbPresente.add("piensan");
        verbPresente.add("corren");
        verbPresente.add("juegan");
        verbPresente.add("estudian");
        verbPresente.add("caminan");
        verbPresente.add("cantan");
        verbPresente.add("cocinan");
        verbPresente.add("esuchan");
        verbPresente.add("limpian");        
    }
    
    private void cargarDiccionarioPalabraSimple(){
        //Lista de palabras simples
        palabraSimple.add("guitarra");
        palabraSimple.add("pelota");
        palabraSimple.add("futbol");
        palabraSimple.add("guitarras");
        palabraSimple.add("pelotas");
    }
        
    private void cargarDiccionarioPreposicion(){
        //Lista de preposiciones
        preposicion.add("a");
        preposicion.add("ante");
        preposicion.add("bajo");
        preposicion.add("cabe");
        preposicion.add("con");
        preposicion.add("contra");
        preposicion.add("de");
        preposicion.add("desde");
        preposicion.add("en");
        preposicion.add("entre");
        preposicion.add("hacia");
        preposicion.add("hasta");
        preposicion.add("mediante");
        preposicion.add("para");
        preposicion.add("por");
        preposicion.add("según");
        preposicion.add("sin");
        preposicion.add("sobre");
        preposicion.add("tras");
        preposicion.add("versus");              
    }
    
}
